

/**
    (C) Copyright Magnus Galåen (magnusga@idi.ntnu.no)
 */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>

#include <fstream>
#include <iostream>
#include <string>
#include <vector>

#include "common/utf8-strings.h"
#include "parser/html_parser.h"
#include "blocks.h"


using namespace std;


int	size_id;
void	*mmap_id;

void io_init()
{
    html_parser_init();

    FILE	*f_id = fopen("id", "r");
    struct stat	inode;

    fstat(fileno(f_id), &inode);
    size_id = inode.st_size;

    mmap_id = mmap(0, size_id, PROT_READ, MAP_PRIVATE, fileno(f_id), 0);
}


int readfile_into_buf( char *filename, char **buf )
{
    FILE        *file = fopen(filename, "r");
    int         i;

    if (!file)
        {
            cerr << "Could not open " << filename << endl;
            return 0;
        }

    // Get filesize:
    struct stat fileinfo;
    fstat( fileno( file ), &fileinfo );

    int         size = fileinfo.st_size;
    *buf = (char*)malloc(sizeof(char)*size);

    for (i=0; i<size;)
        {
            i+= fread( (void*)&((*buf)[i]), sizeof(char), size-i, file );
        }

    fclose(file);

    return size;
}


bool	fn_full=false;
bool	filter_washing=false;

void fn( char *word, int pos, enum parsed_unit pu, enum parsed_unit_flag puf, void *wordlist )
{
/*
    if (pu == pu_eos)
	{
	    vector< vector<string> >	*V = (vector< vector<string> >*)wordlist;

	    V->push_back(vector<string>());
	}
*/
    if (fn_full || pu == pu_word)
	{
	    char	*w_lower = strdup(word);
	    convert_to_lowercase((unsigned char*)w_lower);
	    string	w(w_lower);

	    bool	add = true;

	    if (filter_washing)
		{
		    if (w.size() <= 2) add = false;
		    if (w[0]>='0' && w[0]<='9') add = false;
		}

	    if (add)
		{
/*
		    vector< vector<string> >	&V = *(vector< vector<string> >*)wordlist;

		    if (V.size() == 0) V.push_back(vector<string>());

		    if (V[V.size()-1].size() > 30)	// Force max sentence-length.
			V.push_back(vector<string>());

		    V[V.size()-1].push_back(w);
*/
		    vector<string>	&V = *(vector<string>*)wordlist;
		    V.push_back(w);
		}

	    free(w_lower);
	}
}


//vector< vector<string> > getdocument( int docid, bool full )
pair<vector<string>, char*> getdocument( int docid, bool full )
{
    struct id_block	*doc_d = (struct id_block*)mmap_id;
    doc_d+= docid;

    cout << docid << endl;
    cout << doc_d->url << endl;
    cout << doc_d->path << endl;
    cout << doc_d->category << endl;
    cout << doc_d->title << endl;

    string	doc_fname = "files/";
    doc_fname+= doc_d->path;

    char	*buf;
    int		size;
//    vector <vector<string> >	V;
    vector<string>	V;

    if ((size=readfile_into_buf((char*)doc_fname.c_str(), &buf)) > 0)
	{
    	    char		*title=NULL, *body=NULL;

	    fn_full = full;
	    html_parser_run( doc_d->url, buf, size, &title, &body, fn, (void*)&V );

	    free(buf);
	    free(title);
//	    free(body);

	    return pair<vector<string>, char*>(V, body);
	}

    free(buf);

    return pair<vector<string>, char*>(V, NULL);
}


