
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>

#include <iostream>
#include <fstream>

#include "blocks.h"

using namespace std;


int main(int argc, char *argv[])
{
    ifstream	matrix_dim("matrix_dim");
    int		total_words, total_documents, total_nz;
    matrix_dim >> total_words >> total_documents >> total_nz;

    FILE	*f_dictionary = fopen("dictionary", "r"),
		*f_ii = fopen("ii", "r"),
		*f_id = fopen("id", "r");
    int		size_dictionary, size_ii, size_id;
    int		n_dictionary;
    void	*mmap_dictionary, *mmap_ii, *mmap_id;
    struct stat	inode;

    fstat(fileno(f_dictionary), &inode);
    size_dictionary = inode.st_size;
    n_dictionary = size_dictionary / 32;
    fstat(fileno(f_ii), &inode);
    size_ii = inode.st_size;
    fstat(fileno(f_id), &inode);
    size_id = inode.st_size;

    mmap_dictionary = mmap(0, size_dictionary, PROT_READ, MAP_PRIVATE, fileno(f_dictionary), 0);
    mmap_ii = mmap(0, size_ii, PROT_READ, MAP_PRIVATE, fileno(f_ii), 0);
    mmap_id = mmap(0, size_id, PROT_READ, MAP_PRIVATE, fileno(f_id), 0);

    if (mmap_dictionary == MAP_FAILED || mmap_ii == MAP_FAILED || mmap_id == MAP_FAILED)
	{
	    perror("mmap");
	    exit(-1);
	}

    struct dict_block	*ptr_dict = (struct dict_block*)mmap_dictionary;
    for (int i=0; i<n_dictionary; i++)
	{
	    int		*id_list = (int*)mmap_ii;
	    id_list+= ptr_dict->addr;
	    int		num_words = *id_list;

	    if (num_words > (total_documents*0.1))
	        printf("%6i %s\n", num_words, ptr_dict->word);

	    ptr_dict++;
	}
}
