
#include "input.cpp"


int main(int argc, char *argv[])
{
    if (argc==1)
	{
	    cout << "Usage: " << argv[0] << " <query> <docid1> [<docid2> [...]]" << endl;
	    return 0;
	}

    char	*query = argv[1];

    io_init();

    for (int i=2; i<argc; i++)
	{
	    int		docid = atoi(argv[i]);
	    cout << "Reading document " << docid << "..." << endl;

	    Document	*D = new Document(docid);

	    cout << "url: " << D->getUrl() << endl;
	    cout << "path: " << D->getPath() << endl;
	    cout << "category: " << D->getCategory() << endl;
	    cout << "title: " << D->getTitle() << endl;

	    D->setFilterStemming(true);

	    vector<string>	&V = *D->getdataParagraphsOnly();
	    cout << endl << "PARAGRAPHS:";
	    for (int j=0; j<V.size(); j++)
		cout << " " << V[j];
	    cout << endl;
/*
	    vector<string>	&V = *D->getdataFullDocument();
	    cout << endl << "DOCUMENT:";
	    for (int j=0; j<V.size(); j++)
		cout << " " << V[j];
	    cout << endl;

	    query_array		qa;
	    get_query(query, strlen(query), &qa);

	    V = *D->getdataSnippet(&qa, 320);
	    cout << endl << "SNIPPET:";
	    for (int j=0; j<V.size(); j++)
		cout << " " << V[j];
	    cout << endl;
*/
	    delete D;
	}
}
