
/**
 *	Simple search-system, (C) Copyright Magnus Galåen
 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>

#include <iostream>
//#include <fstream>
#include <list>

extern "C"
{
#include "query/query_parser.h"
//#include "generateSnippet/snippet.parser.h"
}

#include "blocks.h"
#include "output.h"

using namespace std;



int main( int argc, const char *argv[] )
{
    FILE	*f_dictionary = fopen("dictionary", "r"),
		*f_ii = fopen("ii", "r"),
		*f_id = fopen("id", "r");
    int		size_dictionary, size_ii, size_id;
    int		n_dictionary;
    void	*mmap_dictionary, *mmap_ii, *mmap_id;
    struct stat	inode;

    fstat(fileno(f_dictionary), &inode);
    size_dictionary = inode.st_size;
    n_dictionary = size_dictionary / 32;
    fstat(fileno(f_ii), &inode);
    size_ii = inode.st_size;
    fstat(fileno(f_id), &inode);
    size_id = inode.st_size;
//    fstat(fileno(f_summary), &inode);
//    size_summary = inode.st_size;

    mmap_dictionary = mmap(0, size_dictionary, PROT_READ, MAP_PRIVATE, fileno(f_dictionary), 0);
    mmap_ii = mmap(0, size_ii, PROT_READ, MAP_PRIVATE, fileno(f_ii), 0);
    mmap_id = mmap(0, size_id, PROT_READ, MAP_PRIVATE, fileno(f_id), 0);

    if (mmap_dictionary == MAP_FAILED || mmap_ii == MAP_FAILED || mmap_id == MAP_FAILED)
	{
	    perror("mmap");
	    exit(-1);
	}

//    string	query("");
    char	query[1024];
    query[1023] = '\0';

    for (;;)
	{
	    list<int>	result;
	    cout << "Enter query: "; cout.flush();
	    cin.getline(query, 1023);

	    if (!strcmp(query, "q")) break;

	    // Iterate through all documents in index:
	    struct id_block	*ptr = (struct id_block*)mmap_id;
	    int			num=0;
	    for (int docid=0; (int)ptr < (int)mmap_id + size_id; ptr++,docid++)
		{
		    if (!strcmp(query, ptr->category))
			{
			    cout << "."; cout.flush();
			    num++;

			    result.push_back(docid);
			}
		}

	    cout << endl << num << " documents found." << endl;

            if (result.empty())
		{
		    cout << "No match." << endl;
		}
	    else
		{
		    cout << "Result(" << result.size() << "):" << endl;
		    cout << endl;

		    ofstream	f_docs("result_docs");

		    list<int>::iterator		it=result.begin(), stop=result.end();
		    for (; it!=stop; ++it)
			{
			    f_docs << *it << ": " << *it << endl;
			}

		    f_docs.close();

		    cout << "ok" << endl;
		}
	}

    cout << "Good bye!" << endl;

    fclose(f_id);
    fclose(f_ii);
    fclose(f_dictionary);
}
