
/**
 *	Simple search-system, (C) Copyright Magnus Galåen
 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/mman.h>

#include <iostream>
//#include <fstream>
#include <list>

extern "C"
{
#include "query/query_parser.h"
//#include "generateSnippet/snippet.parser.h"
}

#include "blocks.h"
#include "output.h"

using namespace std;



int main( int argc, const char *argv[] )
{
    FILE	*f_dictionary = fopen("dictionary", "r"),
		*f_ii = fopen("ii", "r"),
		*f_id = fopen("id", "r");
    int		size_dictionary, size_ii, size_id;
    int		n_dictionary;
    void	*mmap_dictionary, *mmap_ii, *mmap_id;
    struct stat	inode;

    fstat(fileno(f_dictionary), &inode);
    size_dictionary = inode.st_size;
    n_dictionary = size_dictionary / 32;
    fstat(fileno(f_ii), &inode);
    size_ii = inode.st_size;
    fstat(fileno(f_id), &inode);
    size_id = inode.st_size;
//    fstat(fileno(f_summary), &inode);
//    size_summary = inode.st_size;

    mmap_dictionary = mmap(0, size_dictionary, PROT_READ, MAP_PRIVATE, fileno(f_dictionary), 0);
    mmap_ii = mmap(0, size_ii, PROT_READ, MAP_PRIVATE, fileno(f_ii), 0);
    mmap_id = mmap(0, size_id, PROT_READ, MAP_PRIVATE, fileno(f_id), 0);

    if (mmap_dictionary == MAP_FAILED || mmap_ii == MAP_FAILED || mmap_id == MAP_FAILED)
	{
	    perror("mmap");
	    exit(-1);
	}

//    string	query("");
    char	query[1024];
    query[1023] = '\0';

    for (;;)
	{
	    list<int>	result;
	    int		addr;
	    cout << "Enter query: "; cout.flush();
	    cin.getline(query, 1023);

	    if (!strcmp(query, "q")) break;

	    query_array		qa;
	    get_query(query, strlen(query), &qa);

	    struct dict_block	*part[qa.n];

	    for (int i=0; i<qa.n; i++)
		{
		    part[i] = (struct dict_block*)bsearch(qa.query[i].s[0], mmap_dictionary, n_dictionary, 32, cmp_dict);

		    if (part[i]==NULL)
			{
			    result.clear();
			    break;
			}

		    if (i==0)
			{
			    int		*id_list = (int*)mmap_ii;
			    id_list+= part[i]->addr;
			    int		num = *id_list;
			    id_list++;

			    for (int j=0; j<num; j++)
				{
				    result.push_back( *id_list );
				    id_list++;
				}
			}
		    else // Merge:
			{
			    int		*id_list = (int*)mmap_ii;
			    id_list+= part[i]->addr;
			    int		num = *id_list;
			    id_list++;

			    list<int>::iterator	it=result.begin(), stop=result.end();
			    for (int j=0; j<num && it!=stop; j++)
				{
				    while (*id_list > *it && it!=stop)
					{
					    // Delete
					    list<int>::iterator	old_it = it;
					    ++it;
					    result.erase(old_it);
					}

				    while (*id_list == *it && it!=stop) ++it;

				    id_list++;
				}
			}
		}

	    if (result.empty())
		{
		    cout << "No match." << endl;
		}
	    else
		{
		    cout << "Result(" << result.size() << "):" << endl;
		    cout << endl;
/*
		    cout << "Creating result matrix..." << endl;

		    // _words:
		    ifstream	m_words("matrix_words");
		    ofstream	f_words("result_words");

		    char	s[1024];
		    int		size_words;

		    m_words.getline(s, 1023);
		    size_words = atoi(s);
		    f_words << size_words << endl;

//		    cout << "size_words: " << size_words << endl;

		    int		*W = new int[size_words];

		    for (int i=0; i<size_words; i++)
			{
			    m_words.getline(s, 1023);

			    for (int j=0; s[j]!='\0'; j++)
				if (!((s[j]>='A' && s[j]<='Z')
				    || (s[j]>='a' && s[j]<='z')
				    || (s[j]>='0' && s[j]<='9')))
				    s[j] = '_';

			    f_words << s << endl;
			    W[i] = 0;
			}

		    m_words.close();
//		    cout << "words done." << endl;

		    // _dim, _ccs:
		    ifstream	m_dim("matrix_dim"), m_col_ccs("matrix_col_ccs"), m_row_ccs("matrix_row_ccs"), m_tfn_nz("matrix_tfn_nz");
		    ofstream	f_dim("result_dim"), f_col_ccs("result_col_ccs"), f_row_ccs("result_row_ccs"), f_tfn_nz("result_tfn_nz"), f_docs("result_docs");
*/
		    ofstream	f_docs("result_docs");
/*
		    int		m_rows, m_cols, m_nz;
		    m_dim >> m_rows >> m_cols >> m_nz;

		    int		*colptrs = new int[m_cols+1], *rowindices = new int[m_nz];

		    for (int i=0; i<m_cols+1; i++)
			m_col_ccs >> colptrs[i];

		    for (int i=0; i<m_nz; i++)
			m_row_ccs >> rowindices[i];

		    int		nz = 0;
		    f_col_ccs << "0" << endl;
*/
		    list<int>::iterator		it=result.begin(), stop=result.end();
		    for (; it!=stop; ++it)
			{
/*
			    int		a, b;
			    a = colptrs[*it];
			    b = colptrs[(*it)+1];

//			    cout << "Document " << *it << " (" << a << "," << b << ")" << endl;

			    // Print out wordmatrix for document *it:
			    for (int i=a; i<b; i++)
				{
				    f_row_ccs << rowindices[i] << endl;
				    f_tfn_nz << "1.0" << endl;
//				    cout << "rowindices[" << i << "] = " << rowindices[i] << endl;
				    W[rowindices[i]]++;
				    nz++;
				}

			    f_col_ccs << nz << endl;
*/
			    f_docs << *it << ": " << *it << endl;
			}
/*
		    f_dim << m_rows << " " << result.size() << " " << nz << endl;


		    m_dim.close();
		    m_col_ccs.close();
		    m_row_ccs.close();
		    m_tfn_nz.close();
		    f_dim.close();
		    f_col_ccs.close();
		    f_row_ccs.close();
		    f_tfn_nz.close();
*/
		    f_docs.close();
/*
		    // _words:

		    for (int i=0; i<size_words; i++)
			{
			    f_words << i << " " << W[i] << " " << W[i] << endl;
			}

		    f_words.close();
*/
		    cout << "ok" << endl;

//		    Output	*output = new Output("answer.html", &qa, mmap_id);
//		    output->print_sidebar(result.size());
//		    output->print_snippets(result);
//		    delete output;
		}
	}

    cout << "Good bye!" << endl;

    fclose(f_id);
    fclose(f_ii);
    fclose(f_dictionary);
}
